###########################################################################
########################## generated by setup.py ##########################
###########################################################################
from __future__ import absolute_import
__name__ = 'casatools'
__all__ = [ "ctsys", "version", "version_string"
            'agentflagger',
            'atcafiller',
            'atmosphere',
            'calanalysis',
            'calibrater',
            'componentlist',
            'coordsys',
            'functional',
            'image',
            'imagemetadata',
            'imagepol',
            'imager',
            'iterbotsink',
            'linearmosaic',
            'logsink',
            'measures',
            'miriadfiller',
            'ms',
            'msmetadata',
            'mstransformer',
            'quanta',
            'regionmanager',
            'sakura',
            'sdm',
            'sidebandseparator',
            'simulator',
            'singledishms',
            'spectralline',
            'synthesisdeconvolver',
            'synthesisimager',
            'synthesisimstore',
            'synthesismaskhandler',
            'synthesisnormalizer',
            'synthesisutils',
            'table',
            'tablerow',
            'vlafiller',
            'vpmanager',
          ]
from .agentflagger import agentflagger
from .atcafiller import atcafiller
from .atmosphere import atmosphere
from .calanalysis import calanalysis
from .calibrater import calibrater
from .componentlist import componentlist
from .coordsys import coordsys
from .functional import functional
from .image import image
from .imagemetadata import imagemetadata
from .imagepol import imagepol
from .imager import imager
from .iterbotsink import iterbotsink
from .linearmosaic import linearmosaic
from .logsink import logsink
from .measures import measures
from .miriadfiller import miriadfiller
from .ms import ms
from .msmetadata import msmetadata
from .mstransformer import mstransformer
from .quanta import quanta
from .regionmanager import regionmanager
from .sakura import sakura
from .sdm import sdm
from .sidebandseparator import sidebandseparator
from .simulator import simulator
from .singledishms import singledishms
from .spectralline import spectralline
from .synthesisdeconvolver import synthesisdeconvolver
from .synthesisimager import synthesisimager
from .synthesisimstore import synthesisimstore
from .synthesismaskhandler import synthesismaskhandler
from .synthesisnormalizer import synthesisnormalizer
from .synthesisutils import synthesisutils
from .table import table
from .tablerow import tablerow
from .vlafiller import vlafiller
from .vpmanager import vpmanager
from casatools import ctuser as __user
from .utils import utils as __utils
import os as __os
import sys as __sys

def __find_data_path( ):

    def find_mount_point(path):
        path = __os.path.abspath(path)
        while not __os.path.ismount(path):
            path = __os.path.dirname(path)
        return path

    #potential_data_paths = ['/opt/casa/data', '/home/casa/data/master', '/home/casa/data', '/export/data_1/casa/data']
    potential_data_paths = [ ]
    casadata = [ d for d in (__os.environ['CASADATA'].split(':') if 'CASADATA' in __os.environ else [ ]) if __os.path.isdir(d) ]
    potential = [ d for d in potential_data_paths if __os.path.isdir(d) ]
    potential_local = [ d for d in potential if find_mount_point(d) == '/' ]
    potential_remote = [ d for d in potential if find_mount_point(d) != '/' ]
    used = set( )
    return [ x for x in casadata + potential_local + potential_remote if x not in used and (used.add(x) or True)]

def __find_user_data_path( ):
    def is_iter_container(v):
        try:
            _iter = iter(v)
            return not isinstance(v,str)
        except TypeError:
            return False

    if hasattr(__user,'datapath') and is_iter_container(__user.datapath):
        return list(filter(__os.path.isdir, list(map(__os.path.expanduser,__user.datapath))))
    else:
        return [ ]

def __find_user_nogui( ):
  result = False
  if (hasattr(__user,'nogui') and isinstance(__user.nogui,bool)):
     result = __user.nogui
  return result

def __find_user_agg( ):
  result = False
  if (hasattr(__user,'agg') and isinstance(__user.agg,bool)):
     result = __user.agg
  return result

def __find_user_pipeline( ):
  result = False
  if (hasattr(__user,'pipeline') and isinstance(__user.pipeline,bool)):
     result = __user.pipeline
  return result

sakura( ).initialize_sakura( )    ## sakura requires explicit initialization

ctsys = __utils( )
_distro_dpath = None
_dpath = [ ]

_user_data = None
if hasattr(__user,'rundata'):
     if not __os.path.isdir(__os.path.expanduser(__user.rundata)):
         if __sys.argv[0] != '-m':
             print("ignoring rundata setting (%s) because it is not a directory" % __user.rundata,file=__sys.stderr)
     else:
         _user_data = __os.path.expanduser(__user.rundata)

if _user_data is None:
    try:
        import casashell as __cs
        _user_data = __os.path.expanduser(__os.path.join(__cs._rcdir,'data'))
    except Exception as e:
        _user_data = __os.path.expanduser("~/.casa/data")

if __os.path.isdir(_user_data):
    _dpath = _dpath + [ _user_data ]
    _iers = __os.path.join(_user_data,'geodetic','IERSeop2000')
    if __os.path.isdir(_iers):
        _distro_dpath = _user_data

if _distro_dpath is None:
    try:
        import casadata
        _distro_dpath = casadata.datapath
        _dpath = _dpath + [ _distro_dpath ]
    except: pass

ctsys.initialize( __sys.executable, "" if _distro_dpath is None else _distro_dpath,
                  __find_user_data_path( ) + _dpath,
                  __find_user_nogui( ), __find_user_agg( ), __find_user_pipeline( ) )

if __sys.argv[0] != '-m':
    __resolved_iers = ctsys.resolve('geodetic/IERSeop2000')
    if __resolved_iers == 'geodetic/IERSeop2000':
        raise ImportError('measures data is not available, visit http://go.nrao.edu/casadata-info for more information')
    if len(ctsys.rundata( )) == 0:
        ctsys.setrundata(__resolved_iers[:-21])

from .coercetype import coerce as __coerce

__coerce.set_ctsys(ctsys)         ## used to locate files from a partial path

def version( ): return list(ctsys.toolversion( ))
def version_string( ): return ctsys.toolversion_string( )

import atexit as __atexit
__atexit.register(ctsys.shutdown) ## c++ shutdown
